//
//  MCPickerView.h
//  Tools
//
//  Created by ike on 2017/1/14.
//  Copyright © 2017年 ike. All rights reserved.
//

#import <UIKit/UIKit.h>

typedef NS_ENUM(NSInteger,MCPickerViewStyle){
    MCPickerViewStateNormal = 0,/*默认*/
    MCPickerViewStateDate   = 1/*时间*/
};
typedef void(^MCReturnSelend)(UIPickerView *mcPicker,NSInteger component,NSInteger row,id mcData);
typedef void(^MCReturnJson)(NSString *mcString);
@interface MCPickerView : UIView
@property(nonatomic,copy)MCReturnSelend mcSelend;
@property(nonatomic,copy)MCReturnJson mcString;
#pragma mark 公共的
/**
 设置高度
 */
-(MCPickerView *(^)(CGFloat))mcSetFrameHeight;
#pragma mark pickerView
/**
 加载视图
 style 风格
 */
+(MCPickerView *)mcDefaultMCPickViewTitle:(NSString *)title PickViewStyle:(MCPickerViewStyle)style;
/**
 添加数据
 */
-(MCPickerView *(^)(NSArray *))mcAddPickViewData;
/**
 是否滑动单列 回调操作数据
 默认 NO
 */
@property(nonatomic,assign)BOOL mcIsReturn;
/**
 数据回调
 */
-(void)mcReturnSelendData:(MCReturnSelend)block;
/**
 根据添加的数据进行解析
 类型格式 mcAge:component key:解析数据
 注:Value 可字典
 */
-(MCPickerView *(^)(NSInteger mcAge,NSString*key))mcJsonData;
/**
 数据替换
 */
-(void)mcSetArrayComponent:(int)component showArray:(NSArray *)array;
#pragma mark dataPicker
/**
 设置datePicker 最大日期
 */
-(MCPickerView *(^)(NSDate *))mcMaxDate;
/**
 设置datePicker 最小日期
 */
-(MCPickerView *(^)(NSDate *))mcMiniDate;
/**
 设置datePicker 风格
 */
-(MCPickerView *(^)(UIDatePickerMode))mcPickerMode;
/**
 滑动间隔时间 Interval
 */
-(MCPickerView *(^)(NSInteger))mcPickerInterval;
@end
