//
//  MCPickerView.m
//  Tools
//
//  Created by ike on 2017/1/14.
//  Copyright © 2017年 ike. All rights reserved.
//

#import "MCPickerView.h"

@interface MCPickerView ()<UIPickerViewDelegate,UIPickerViewDataSource>{
    NSMutableArray *allArray;
    __weak IBOutlet UIPickerView *pickView;
    NSMutableDictionary *mcSelendDict;
    NSMutableDictionary *mcJsonDict;
    __weak IBOutlet NSLayoutConstraint *pickView_H;
    __weak IBOutlet NSLayoutConstraint *datePicker_H;
    __weak IBOutlet UIDatePicker *datePicker;
    NSInteger type;
}
@property (weak, nonatomic) IBOutlet UILabel *titleLabel;

@end

@implementation MCPickerView

-(void)awakeFromNib{
    [super awakeFromNib];
    pickView.delegate = self;
    pickView.dataSource = self;
    allArray = [NSMutableArray arrayWithCapacity:0];
    mcSelendDict = [NSMutableDictionary dictionaryWithCapacity:0];
    mcJsonDict = [NSMutableDictionary dictionaryWithCapacity:0];
    self.mcIsReturn = NO;
    
}
-(MCPickerView *(^)(NSInteger mcAge,NSString*key))mcJsonData{
    return ^MCPickerView *(NSInteger mcAge,NSString*key){
        type = 0;
        [mcJsonDict setObject:key forKey:@(mcAge)];
        return self;
    };
}
-(MCPickerView *(^)(NSArray *))mcAddPickViewData{
    return ^MCPickerView *(NSArray *array){
        type = 0;
        [allArray addObject:array];
        [pickView reloadComponent:allArray.count - 1];
        return self;
    };
}
-(MCPickerView *(^)(CGFloat))mcSetFrameHeight{
    return ^MCPickerView *(CGFloat height){
        pickView_H.constant = height;
        datePicker_H.constant = height;
        return self;
    };
}
-(void)mcSetArrayComponent:(int)component showArray:(NSArray *)array{
    [allArray replaceObjectAtIndex:component withObject:array];
    [pickView reloadComponent:component];
}
/**
 设置dataPicker 最大日期
 maxDate:日期
 */
-(MCPickerView *(^)(NSDate *maxDate))mcMaxDate{
    return ^MCPickerView *(NSDate *maxDate){
        type = 1;
        [datePicker setMaximumDate:maxDate];
        return self;
    };
}
/**
 设置dataPicker 最小日期
 */
-(MCPickerView *(^)(NSDate *))mcMiniDate{
    return ^MCPickerView *(NSDate *miniDate){
        type = 1;
        [datePicker setMinimumDate:miniDate];
        return self;
    };
};
/**
 设置datePicker 风格
 */
-(MCPickerView *(^)(UIDatePickerMode))mcPickerMode{
    return ^MCPickerView *(UIDatePickerMode pickerMode){
        type = 1;
        [datePicker setDatePickerMode:pickerMode];
        return self;
    };
}
/**
 滑动间隔时间 Interval
 */
-(MCPickerView *(^)(NSInteger))mcPickerInterval{
    return ^MCPickerView *(NSInteger Interval){
        type = 1;
        [datePicker setMinuteInterval:Interval];
        return self;
    };
}
-(void)mcReturnSelendData:(MCReturnSelend)block{
    self.mcSelend = block;
}
+(MCPickerView *)mcDefaultMCPickViewTitle:(NSString *)title PickViewStyle:(MCPickerViewStyle)style{
    MCPickerView *PickViewAlert;
    if(style == MCPickerViewStateNormal){
        PickViewAlert = [[[NSBundle mainBundle]loadNibNamed:@"MCPickerView" owner:nil options:nil]objectAtIndex:0];
    }else{
        PickViewAlert = [[[NSBundle mainBundle]loadNibNamed:@"MCPickerView" owner:nil options:nil]objectAtIndex:1];
    }
    PickViewAlert.titleLabel.text = title;
    UIWindow *window =  [UIApplication sharedApplication].delegate.window;
    PickViewAlert.frame = [[UIScreen mainScreen] bounds];
    [window addSubview:PickViewAlert];
    return PickViewAlert;
}
- (IBAction)buttonClick:(UIButton *)sender{
    [self removeFromSuperview];
    if (type == 1) {
        self.mcSelend(nil,0,0,datePicker.date);
    }else{
        if (sender.tag == 1){
            if (mcSelendDict.allKeys.count == 0){
                for (int i = 0; i < allArray.count; i ++) {
                    [mcSelendDict setObject:allArray[i][0] forKey:@(i)];
                }
            }
            self.mcSelend(pickView,0,0,mcSelendDict);
        }
    }
    
}
-(NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView{
    return allArray.count;
}
-(NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component{
    return [allArray[component] count];
}
-(NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component{
    return [self mcComponent:component showRow:row];
}
- (UIView *)pickerView:(UIPickerView *)pickerView viewForRow:(NSInteger)row forComponent:(NSInteger)component reusingView:(UIView *)view{
    UILabel* pickerLabel = (UILabel*)view;
    if (!pickerLabel){
        pickerLabel = [[UILabel alloc] init];
        // Setup label properties - frame, font, colors etc
        //adjustsFontSizeToFitWidth property to YES
        pickerLabel.adjustsFontSizeToFitWidth = YES;
        [pickerLabel setTextAlignment:NSTextAlignmentCenter];
        [pickerLabel setBackgroundColor:[UIColor clearColor]];
        [pickerLabel setFont:[UIFont boldSystemFontOfSize:14]];
    }
    // Fill the label text here
    pickerLabel.text=[self pickerView:pickerView titleForRow:row forComponent:component];
    return pickerLabel;
}
-(void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
    [mcSelendDict setObject:[self mcComponent:component showRow:row] forKey:@(component)];
    if (self.mcIsReturn == YES) {
        if (component != allArray.count -1){
            self.mcSelend(pickView,component,row,mcSelendDict);
        }
    }
}
-(NSString *)mcComponent:(NSInteger)com showRow:(NSInteger)ro{
    if (mcJsonDict.allKeys.count > 0){
        if ([mcJsonDict.allKeys containsObject:@(com)]){
            if ([mcJsonDict[@(com)] isKindOfClass:[NSDictionary class]]){
                NSDictionary *dict = [NSDictionary dictionaryWithDictionary:mcJsonDict[@(com)]];
                if ([allArray[com][ro] isKindOfClass:[NSDictionary class]]) {
                    NSDictionary *compometDict = [NSDictionary dictionaryWithDictionary:allArray[com][ro]];
                    NSArray *rowArray = [NSArray arrayWithArray:dict.allKeys];
                    if ([compometDict[rowArray[0]] isKindOfClass:[NSDictionary class]]) {
                        NSDictionary *rowDict = [NSDictionary dictionaryWithDictionary:compometDict[rowArray[0]]];
                        return rowDict[dict[rowArray[0]]];
                    }else{
                        return compometDict[rowArray[0]][ro];
                    }
                }else{
                    return allArray[com][ro];
                }
            }else{
                if ([allArray[com][ro] isKindOfClass:[NSDictionary class]]) {
                    NSDictionary *compometDict = [NSDictionary dictionaryWithDictionary:allArray[com][ro]];
                    return compometDict[[NSString stringWithFormat:@"%@",mcJsonDict[@(com)]]];
                }else{
                    return allArray[com][ro];
                }
            }
        }else{
            return allArray[com][ro];
        }
    }else{
        return allArray[com][ro];
    }
}
@end
